Index: /trunk/sources/HeuristicLab.ExtLibs.sln
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs.sln	(revision 13158)
+++ /trunk/sources/HeuristicLab.ExtLibs.sln	(revision 13159)
@@ -72,4 +72,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.SimSharp-3.0.7", "HeuristicLab.ExtLibs\HeuristicLab.SimSharp\3.0.7\HeuristicLab.SimSharp-3.0.7\HeuristicLab.SimSharp-3.0.7.csproj", "{5C93CAF7-AE6A-4540-95B2-5DA6761A2677}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.SharpDX-2.6.3", "HeuristicLab.ExtLibs\HeuristicLab.SharpDX\2.6.3\HeuristicLab.SharpDX-2.6.3\HeuristicLab.SharpDX-2.6.3.csproj", "{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}"
 EndProject
 Global
@@ -467,4 +469,16 @@
 		{5C93CAF7-AE6A-4540-95B2-5DA6761A2677}.Release|x86.ActiveCfg = Release|x86
 		{5C93CAF7-AE6A-4540-95B2-5DA6761A2677}.Release|x86.Build.0 = Release|x86
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Debug|x64.ActiveCfg = Debug|x64
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Debug|x64.Build.0 = Debug|x64
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Debug|x86.ActiveCfg = Debug|x86
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Debug|x86.Build.0 = Debug|x86
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Release|Any CPU.Build.0 = Release|Any CPU
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Release|x64.ActiveCfg = Release|x64
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Release|x64.Build.0 = Release|x64
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Release|x86.ActiveCfg = Release|x86
+		{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/HeuristicLab.SharpDX-2.6.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/HeuristicLab.SharpDX-2.6.3.csproj	(revision 13159)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/HeuristicLab.SharpDX-2.6.3.csproj	(revision 13159)
@@ -0,0 +1,255 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{E40E7DFE-5CCF-49DC-8DD0-A795ABF18985}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.SharpDX</RootNamespace>
+    <AssemblyName>HeuristicLab.SharpDX-2.6.3</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <TargetFrameworkProfile>
+    </TargetFrameworkProfile>
+    <FileAlignment>512</FileAlignment>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+    <FileUpgradeFlags>
+    </FileUpgradeFlags>
+    <OldToolsVersion>3.5</OldToolsVersion>
+    <UpgradeBackupLocation />
+    <PublishUrl>publish\</PublishUrl>
+    <Install>true</Install>
+    <InstallFrom>Disk</InstallFrom>
+    <UpdateEnabled>false</UpdateEnabled>
+    <UpdateMode>Foreground</UpdateMode>
+    <UpdateInterval>7</UpdateInterval>
+    <UpdateIntervalUnits>Days</UpdateIntervalUnits>
+    <UpdatePeriodically>false</UpdatePeriodically>
+    <UpdateRequired>false</UpdateRequired>
+    <MapFileExtensions>true</MapFileExtensions>
+    <ApplicationRevision>0</ApplicationRevision>
+    <ApplicationVersion>1.0.0.%2a</ApplicationVersion>
+    <IsWebBootstrapper>false</IsWebBootstrapper>
+    <UseApplicationTrust>false</UseApplicationTrust>
+    <BootstrapperEnabled>true</BootstrapperEnabled>
+    <SolutionDir Condition="$(SolutionDir) == '' Or $(SolutionDir) == '*Undefined*'">..\..\..\..\</SolutionDir>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <Content Include="Assimp32.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="Assimp64.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="AssimpNet.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="License-SharpDX-2.6.3.txt">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.D3DCompiler.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Direct2D1.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Direct3D10.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Direct3D11.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Direct3D11.Effects.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Direct3D9.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.DirectInput.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.DirectSound.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.DXGI.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.MediaFoundation.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.RawInput.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Toolkit.Audio.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Toolkit.Compiler.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Toolkit.CompilerTask.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Toolkit.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Toolkit.Game.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Toolkit.Graphics.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.Toolkit.Input.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.XACT3.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.XAudio2.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="SharpDX.XInput.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="sharpdx_direct3d11_1_effects_arm.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="sharpdx_direct3d11_1_effects_x64.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="sharpdx_direct3d11_1_effects_x86.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="sharpdx_direct3d11_effects_x64.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="sharpdx_direct3d11_effects_x86.dll">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="tkfont.exe">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="tkfxc.exe">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <Content Include="tkmodel.exe">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <PropertyGroup>
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+export ProjectDir=$(ProjectDir)
+export SolutionDir=$(SolutionDir)
+
+$SolutionDir/PreBuildEvent.sh
+</PreBuildEvent>
+  </PropertyGroup>
+  <Import Project="$(SolutionDir)\.nuget\nuget.targets" />
+</Project>
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/License-SharpDX-2.6.3.txt
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/License-SharpDX-2.6.3.txt	(revision 13159)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/License-SharpDX-2.6.3.txt	(revision 13159)
@@ -0,0 +1,21 @@
+﻿SharpDX is an open-source project, free of charge available under the following MIT License:
+
+Copyright (c) 2010-2012 SharpDX - Alexandre Mutel
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+THE SOFTWARE.
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/Plugin.cs.frame	(revision 13159)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/Plugin.cs.frame	(revision 13159)
@@ -0,0 +1,64 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.SharpDX {
+  [Plugin("HeuristicLab.SharpDX","HeuristicLab wrapper for SharpDX","2.6.3.$WCREV$")]  
+  [PluginFile("HeuristicLab.SharpDX-2.6.3.dll", PluginFileType.Assembly)]
+  [PluginFile("License-SharpDX-2.6.3.txt", PluginFileType.License)]
+  [PluginFile("SharpDX.dll", PluginFileType.Assembly)] // only this assembly should be loaded automatically by the plugin-infrastructure
+  // the remaining files should be loaded by SharpDX or automatically through references
+  [PluginFile("Assimp32.dll", PluginFileType.NativeDll)]
+  [PluginFile("Assimp64.dll", PluginFileType.NativeDll)]
+  [PluginFile("AssimpNet.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.D3DCompiler.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Direct2D1.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Direct3D10.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Direct3D11.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Direct3D11.Effects.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Direct3D9.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.DirectInput.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.DirectSound.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.DXGI.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.MediaFoundation.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.RawInput.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Toolkit.Audio.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Toolkit.Compiler.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Toolkit.CompilerTask.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Toolkit.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Toolkit.Game.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Toolkit.Graphics.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.Toolkit.Input.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.XACT3.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.XAudio2.dll", PluginFileType.Assembly)]
+  [PluginFile("SharpDX.XInput.dll", PluginFileType.Assembly)]
+  [PluginFile("sharpdx_direct3d11_1_effects_arm.dll", PluginFileType.NativeDll)]
+  [PluginFile("sharpdx_direct3d11_1_effects_x64.dll", PluginFileType.NativeDll)]
+  [PluginFile("sharpdx_direct3d11_1_effects_x86.dll", PluginFileType.NativeDll)]
+  [PluginFile("sharpdx_direct3d11_effects_x64.dll", PluginFileType.NativeDll)]
+  [PluginFile("sharpdx_direct3d11_effects_x86.dll", PluginFileType.NativeDll)]
+  [PluginFile("tkfont.exe", PluginFileType.Data)]
+  [PluginFile("tkfxc.exe", PluginFileType.Data)]
+  [PluginFile("tkmodel.exe", PluginFileType.Data)]
+  public class HeuristicLabSharpDxPlugin : PluginBase {
+  }
+}
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/Properties/AssemblyInfo.cs.frame	(revision 13159)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDX/2.6.3/HeuristicLab.SharpDX-2.6.3/Properties/AssemblyInfo.cs.frame	(revision 13159)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+using HeuristicLab.PluginInfrastructure;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.SharpDX")]
+[assembly: AssemblyDescription("Provides an interface to SharpDX")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2015 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("6CAE81C6-D65B-45B5-8824-BB87C89C9CB2")]
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("2.6.3")]
+[assembly: AssemblyFileVersion("2.6.3.$WCREV$")]