Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Plugin.cs.frame
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Plugin.cs.frame	(revision 13160)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Plugin.cs.frame	(revision 13161)
@@ -28,8 +28,10 @@
   [Plugin("HeuristicLab.Problems.BinPacking.Views", "3.3.7.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.BinPacking.Views-3.3.dll", PluginFileType.Assembly)]
+  [PluginFile("PackingPlanVisualizations.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.SharpDX", "2.6.3")]
   public class HeuristicLabProblemsBinPackingViewsPlugin : PluginBase {
   }
Index: /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs	(revision 13160)
+++ /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs	(revision 13161)
@@ -62,5 +62,5 @@
     private void InitializeRenderTarget() {
       hwndProperties.Hwnd = this.Handle;
-      hwndProperties.PixelSize = new DrawingSize(this.Width, this.Height);
+      hwndProperties.PixelSize = new Size2(this.Width, this.Height);
       hwndProperties.PresentOptions = PresentOptions.None;
       textFormat = new TextFormat(dwFactory, "arial", 14);
@@ -130,5 +130,5 @@
     private void PackingPlan2D_Resize(object sender, EventArgs e) {
       if (wndRender != null)
-        wndRender.Resize(new DrawingSize(this.Width, this.Height));
+        wndRender.Resize(new Size2(this.Width, this.Height));
       //this.Refresh();
     }
Index: /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingGame.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingGame.cs	(revision 13160)
+++ /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingGame.cs	(revision 13161)
@@ -22,10 +22,11 @@
 using System;
 using SharpDX;
-using SharpDX.Toolkit;     
+using SharpDX.Direct3D11;
+using SharpDX.Toolkit;
 using SharpDX.Toolkit.Graphics;
 using SharpDX.Toolkit.Input;
 
 using ButtonStateDX = SharpDX.Toolkit.Input.ButtonState;
-using SharpDX.Direct3D11;
+
 
 namespace PackingPlanVisualizations {
@@ -33,5 +34,5 @@
 
 
-    #region Global Private Variables   
+    #region Global Private Variables
     private GraphicsDeviceManager graphicsDeviceManager;
     private PackingPlan3D control;
@@ -42,10 +43,10 @@
     private int selectedItemIndex = -1;
 
-    private BasicEffect basicEffect;      
+    private BasicEffect basicEffect;
     private Color backgroundColor { get; set; }
 
-    private CenteredContainer container;   
+    private CenteredContainer container;
     private MouseManager Mouse;
-    #endregion Global Private Variables     
+    #endregion Global Private Variables
 
     protected override void Dispose(bool disposeManagedResources) {
@@ -58,14 +59,14 @@
     public PackingGame(PackingPlan3D control)
       : base() {
-        this.control = control;
+      this.control = control;
       graphicsDeviceManager = new GraphicsDeviceManager(this);
       graphicsDeviceManager.PreferMultiSampling = true;
-      graphicsDeviceManager.PreparingDeviceSettings += 
-        (object sender, PreparingDeviceSettingsEventArgs e) => {           
+      graphicsDeviceManager.PreparingDeviceSettings +=
+        (object sender, PreparingDeviceSettingsEventArgs e) => {
           e.GraphicsDeviceInformation.PresentationParameters.MultiSampleCount = MSAALevel.X4;
           return;
         };
       var controlColor = Color.White;//System.Drawing.SystemColors.Control;
-      backgroundColor = new Color (controlColor.R,controlColor.G, controlColor.B, controlColor.A);
+      backgroundColor = new Color(controlColor.R, controlColor.G, controlColor.B, controlColor.A);
 
       Mouse = new MouseManager(this);
@@ -135,5 +136,5 @@
       //Primitive color
       basicEffect.AmbientLightColor = new Vector3(0.1f, 0.1f, 0.1f);
-      basicEffect.DiffuseColor = new Vector3(1.0f, 1.0f, 1.0f);
+      basicEffect.DiffuseColor = new Vector4(1.0f, 1.0f, 1.0f, 1.0f);
       basicEffect.SpecularColor = new Vector3(0.25f, 0.25f, 0.25f);
       basicEffect.SpecularPower = 5.0f;
@@ -204,5 +205,5 @@
       GraphicsDevice.Clear(backgroundColor);
 
-      worldMatrix = 
+      worldMatrix =
         Matrix.RotationY(MathUtil.DegreesToRadians(-currentViewAngle.X / 4)) *
         Matrix.RotationX(MathUtil.DegreesToRadians(currentViewAngle.Y / 4));
@@ -229,5 +230,5 @@
                 item.RenderShapeTriangles(GraphicsDevice);
               } else
-                item.RenderShapeLines(GraphicsDevice, new Color(0,0,0));
+                item.RenderShapeLines(GraphicsDevice, new Color(0, 0, 0));
             }
           }
@@ -235,5 +236,5 @@
       }
 
-      base.Draw(gameTime);        
+      base.Draw(gameTime);
     }
 
@@ -244,5 +245,5 @@
 
     protected override void Update(GameTime gameTime) {
-      computeMouseHandling();                                      
+      computeMouseHandling();
       base.Update(gameTime);
     }
@@ -263,10 +264,10 @@
     private void computeLeftMouseBtnHandling(MouseState mouseState) {
       //Left btn released
-      if (mouseState.Left.Equals(ButtonStateDX.Released) && mouseState.Left.Equals(previousMouseState.Left)) {
+      if (mouseState.LeftButton.Released && mouseState.LeftButton.Equals(previousMouseState.LeftButton)) {
         //Console.WriteLine("Released");
       }
 
       //Left btn pressed
-      else if (mouseState.Left.Equals(ButtonStateDX.Pressed) && mouseState.Left.Equals(previousMouseState.Left)) {
+      else if (mouseState.LeftButton.Pressed && mouseState.LeftButton.Equals(previousMouseState.LeftButton)) {
         currentViewAngle = new Vector2(
           viewAngleOnBtnRelease.X + mouseState.X - mousePositionOnBtnDown.X,
@@ -279,5 +280,5 @@
 
       //Left btn freshly pressed ==> ONLICK-EVENT
-      else if (mouseState.Left.Equals(ButtonStateDX.Pressed) && !previousMouseState.Left.Equals(ButtonStateDX.Pressed)) {
+      else if (mouseState.LeftButton.Pressed && !previousMouseState.LeftButton.Pressed) {
         Console.WriteLine("OnClick");
         PackingPlan3D native = (PackingPlan3D)Window.NativeWindow;
@@ -293,5 +294,5 @@
 
       //Left btn freshly released ==> ONRELEASE-EVENT
-      else if (mouseState.Left.Equals(ButtonStateDX.Released) && !previousMouseState.Left.Equals(ButtonStateDX.Released)) {
+      else if (mouseState.LeftButton.Released && !previousMouseState.LeftButton.Released) {
         Console.WriteLine("OnRelease");
         viewAngleOnBtnRelease = currentViewAngle;
Index: /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/PackingPlanVisualizations.csproj
===================================================================
--- /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/PackingPlanVisualizations.csproj	(revision 13160)
+++ /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/PackingPlanVisualizations.csproj	(revision 13161)
@@ -42,46 +42,35 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="SharpDX, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.dll</HintPath>
+    <Reference Include="SharpDX">
+      <HintPath>..\..\..\trunk\sources\bin\SharpDX.dll</HintPath>
+      <Private>False</Private>
     </Reference>
-    <Reference Include="SharpDX.D3DCompiler, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.D3DCompiler.dll</HintPath>
+    <Reference Include="SharpDX.Direct2D1">
+      <HintPath>..\..\..\trunk\sources\bin\SharpDX.Direct2D1.dll</HintPath>
+      <Private>False</Private>
     </Reference>
-    <Reference Include="SharpDX.Direct2D1, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.Direct2D1.dll</HintPath>
+    <Reference Include="SharpDX.Direct3D11">
+      <HintPath>..\..\..\trunk\sources\bin\SharpDX.Direct3D11.dll</HintPath>
+      <Private>False</Private>
     </Reference>
-    <Reference Include="SharpDX.Direct3D11, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.Direct3D11.dll</HintPath>
+    <Reference Include="SharpDX.DXGI">
+      <HintPath>..\..\..\trunk\sources\bin\SharpDX.DXGI.dll</HintPath>
+      <Private>False</Private>
     </Reference>
-    <Reference Include="SharpDX.DirectInput, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.DirectInput.dll</HintPath>
+    <Reference Include="SharpDX.Toolkit">
+      <HintPath>..\..\..\trunk\sources\bin\SharpDX.Toolkit.dll</HintPath>
+      <Private>False</Private>
     </Reference>
-    <Reference Include="SharpDX.DXGI, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.DXGI.dll</HintPath>
+    <Reference Include="SharpDX.Toolkit.Game">
+      <HintPath>..\..\..\trunk\sources\bin\SharpDX.Toolkit.Game.dll</HintPath>
+      <Private>False</Private>
     </Reference>
-    <Reference Include="SharpDX.Toolkit, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.Toolkit.dll</HintPath>
+    <Reference Include="SharpDX.Toolkit.Graphics">
+      <HintPath>..\..\..\trunk\sources\bin\SharpDX.Toolkit.Graphics.dll</HintPath>
+      <Private>False</Private>
     </Reference>
-    <Reference Include="SharpDX.Toolkit.Compiler, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.Toolkit.Compiler.dll</HintPath>
-    </Reference>
-    <Reference Include="SharpDX.Toolkit.Game, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.Toolkit.Game.dll</HintPath>
-    </Reference>
-    <Reference Include="SharpDX.Toolkit.Graphics, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.Toolkit.Graphics.dll</HintPath>
-    </Reference>
-    <Reference Include="SharpDX.Toolkit.Input, Version=2.5.0.0, Culture=neutral, PublicKeyToken=627a3d6d1956f55a, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\SharpDXNightly\Bin\Signed-net40\SharpDX.Toolkit.Input.dll</HintPath>
+    <Reference Include="SharpDX.Toolkit.Input">
+      <HintPath>..\..\..\trunk\sources\bin\SharpDX.Toolkit.Input.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="System" />
@@ -128,28 +117,4 @@
     <None Include="HeuristicLab.snk" />
   </ItemGroup>
-  <ItemGroup>
-    <Content Include="SharpDX\SharpDX.D3DCompiler.dll" />
-    <Content Include="SharpDX\SharpDX.D3DCompiler.xml" />
-    <Content Include="SharpDX\SharpDX.Direct2D1.dll" />
-    <Content Include="SharpDX\SharpDX.Direct2D1.xml" />
-    <Content Include="SharpDX\SharpDX.Direct3D11.dll" />
-    <Content Include="SharpDX\SharpDX.Direct3D11.xml" />
-    <Content Include="SharpDX\SharpDX.DirectInput.dll" />
-    <Content Include="SharpDX\SharpDX.DirectInput.xml" />
-    <Content Include="SharpDX\SharpDX.dll" />
-    <Content Include="SharpDX\SharpDX.DXGI.dll" />
-    <Content Include="SharpDX\SharpDX.DXGI.xml" />
-    <Content Include="SharpDX\SharpDX.Toolkit.Compiler.dll" />
-    <Content Include="SharpDX\SharpDX.Toolkit.Compiler.xml" />
-    <Content Include="SharpDX\SharpDX.Toolkit.dll" />
-    <Content Include="SharpDX\SharpDX.Toolkit.Game.dll" />
-    <Content Include="SharpDX\SharpDX.Toolkit.Game.xml" />
-    <Content Include="SharpDX\SharpDX.Toolkit.Graphics.dll" />
-    <Content Include="SharpDX\SharpDX.Toolkit.Graphics.xml" />
-    <Content Include="SharpDX\SharpDX.Toolkit.Input.dll" />
-    <Content Include="SharpDX\SharpDX.Toolkit.Input.xml" />
-    <Content Include="SharpDX\SharpDX.Toolkit.xml" />
-    <Content Include="SharpDX\SharpDX.xml" />
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 